package domowe.r4.pan_tadeusz;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

public class PoliczWszystkieSlowa_v3 {
    // W tej wersji stosuję nowe (Java 8) "funkcyjne" operacje:
    // - forEachRemaining, która zastpuje nam pętlę while i w inny sposób pozwala przejść przez słowa
    // - merge, która aktualizuje zawartość słownika
    // W tej wersji nie są jeszcze używane strumienie.
    
    public static void main(String[] args) {
        Map<String, Integer> slownik = new TreeMap<>();
        
        try(Scanner scanner = new Scanner(new File("pliki/pan_tadeusz.txt"))) {
            scanner.useDelimiter("[^\\p{L}\\d]+");
            scanner.forEachRemaining(slowo -> slownik.merge(slowo, 1, Integer::sum));
        } catch(FileNotFoundException e) {
            e.printStackTrace();
        }
        
        for(Map.Entry<String, Integer> entry : slownik.entrySet()) {
            System.out.println(entry.getKey() + " → " + entry.getValue());
        }
    }

}
